package org.apache.commons.text.spell;

/**
 * This interfaces provides services dealing with recognizing words.
 * 
 *
 */
public interface Tokenizer {
   public String parseWord(String text);
   public String parseWord(String text, int start);
   public String parseWord(String text, int start, int length);

   public String normalizeWord(String word) throws SpellException;
   
   public boolean isWord(String word);
   public boolean isNormalizedWord(String word);

}
